unit MainCode;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, VCL.UI,
  Vcl.ExtCtrls, frameContact;

type
  TMainFrm = class(TForm)
    grpContactList: TGroupBox;
    lvContacts: TListView;
    Splitter1: TSplitter;
    Panel1: TPanel;
    ContactFrame1: TContactFrame;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    FContactListUI : TContactListViewGrid;
    procedure SubscribeMessages;
  public
    { Public declarations }
  end;

var
  MainFrm: TMainFrm;

implementation

uses DMain, System.Messaging,BothSides.Messages, BothSides.Entities;

{$R *.dfm}

procedure TMainFrm.FormShow(Sender: TObject);
begin
  FContactListUI := TContactListViewGrid.Create( lvContacts );
  FContactListUI.PrepareForUserInteraction;
  SubscribeMessages;
  DMMain.MsgManager.SendMessage( Self, TUILoadContactsRequest.Create );
end;

procedure TMainFrm.SubscribeMessages;
begin
  DMMain.MsgManager.SubscribeToMessage( TUILoadContacts, procedure( const Sender: TObject; const Msg : TMessage )
                                                          var UILoadContacts: TUILoadContacts;
                                                              Contact : TContact;
                                                          begin
                                                            UILoadContacts := TUILoadContacts( Msg );
                                                            for Contact in UILoadContacts.Value do
                                                              begin
                                                                FContactListUI.DataList.Add( Contact );
                                                              end;
                                                              FContactListUI.FillList;
                                                          end);
  DMMain.MsgManager.SubscribeToMessage( TNewContactAdded,procedure( const Sender: TObject;const Msg: TMessage )
                                                         var NewContactAdded : TNewContactAdded;
                                                             Contact : TContact;
                                                         begin
                                                           NewContactAdded := TNewContactAdded( Msg );
                                                           Contact := NewContactAdded.Value;
                                                           FContactListUI.DataList.Add( Contact );
                                                           FContactListUI.FillList;
                                                         end);
  DMMain.MsgManager.SubscribeToMessage( TContactChanged, procedure( const Sender: TObject;const Msg : TMessage )
                                                         var ContactChanged : TContactChanged;
                                                         begin
                                                           ContactChanged := TContactChanged( Msg );
                                                           FContactListUI.Contacts[ ContactChanged.Value.Id ] := ContactChanged.Value;
                                                           FContactListUI.FillList;
                                                         end);
end;

end.
