unit frameContact;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  System.Actions, Vcl.ActnList;

type
  TContactFrame = class(TFrame)
    txtContactName: TLabeledEdit;
    txtEmail: TLabeledEdit;
    Panel1: TPanel;
    btnSave: TButton;
    alFrame: TActionList;
    actSave: TAction;
    btnNew: TButton;
    actNew: TAction;
    actClear: TAction;
    btnClear: TButton;
    procedure actNewExecute(Sender: TObject);
    procedure actClearExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
  private
    FID: Integer;
    { Private declarations }
    procedure  SubscribeMessages;
    function GetContactName: String;
    function GetEmail: String;
    procedure SetContactName(const Value: String);
    procedure SetEmail(const Value: String);
    procedure SetID(const Value: Integer);
  public
    constructor Create(AOwner: TComponent); override;
    { Public declarations }
    property ContactName : String read GetContactName write SetContactName;
    property Email : String read GetEmail write SetEmail;
    property ID : Integer read FID write SetID;
  end;

implementation

uses DMain, System.Messaging, BothSides.Messages, BothSides.Entities;

{$R *.dfm}

{ TContactFrame }

procedure TContactFrame.actClearExecute(Sender: TObject);
begin
  ContactName := '';
  Email := '';
end;

procedure TContactFrame.actNewExecute(Sender: TObject);
var Contact : TContact;
begin
  Contact.Name := ContactName;
  Contact.Email := Email;
  DMMain.MsgManager.SendMessage( self, TNewContactAdd.Create( Contact ));
end;

procedure TContactFrame.actSaveExecute(Sender: TObject);
var Contact: TContact;
begin
  Contact.Id := ID;
  Contact.Name := ContactName;
  Contact.Email := Email;
  DMMain.MsgManager.SendMessage( Self, TContactChanged.Create( Contact ) );
end;

constructor TContactFrame.Create(AOwner: TComponent);
begin
  inherited;
  SubscribeMessages;
end;

function TContactFrame.GetContactName: String;
begin
  Result := txtContactName.Text;
end;

function TContactFrame.GetEmail: String;
begin
  Result := txtEmail.Text;
end;

procedure TContactFrame.SetContactName(const Value: String);
begin
  txtContactName.Text := Value;
end;

procedure TContactFrame.SetEmail(const Value: String);
begin
  txtEmail.Text := Value;
end;

procedure TContactFrame.SetID(const Value: Integer);
begin
  FID := Value;
end;

procedure TContactFrame.SubscribeMessages;
begin
  DMMain.MsgManager.SubscribeToMessage( TContactDblClicked, procedure( const Sender: TObject;const Msg: TMessage )
                                                            var Mesg: TContactDblClicked;
                                                            begin
                                                              Mesg := TContactDblClicked( Msg );
                                                              ContactName := Mesg.Value.Name;
                                                              Email := Mesg.Value.Email;
                                                              Id := Mesg.Value.Id;
                                                            end)
end;

end.
